unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, CheckLst, ExtCtrls,
  StdCtrls, ComCtrls, TAGraph, TASources, TASeries, TATools, TADataTools, Types;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    ChartToolset1: TChartToolset;
    ImageList1: TImageList;
    ListBox1: TListBox;
    Panel1: TPanel;
    RandomChartSource1: TRandomChartSource;
    Splitter1: TSplitter;
    ToolBar1: TToolBar;
    tbAdd: TToolButton;
    tbDelete: TToolButton;
    tbEdit: TToolButton;
    procedure ChartToolset1DataPointDistanceTool1AfterMouseUp(
      ATool: TChartTool; APoint: TPoint);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1SelectionChange(Sender: TObject; User: boolean);
    procedure tbAddClick(Sender: TObject);
    procedure tbDeleteClick(Sender: TObject);
    procedure tbEditClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math;

{ TForm1 }

{ Eine Messung ist beendet. Das Ergebnis wird in die Listbox eingetragen, dabei
  wird das verwendete DistanceTools als Object mit in die Listbox eingehängt. }
procedure TForm1.ChartToolset1DataPointDistanceTool1AfterMouseUp(
  ATool: TChartTool; APoint: TPoint);
var
  t: TDatapointDistanceTool;
  j: Integer;
begin
  t := ATool as TDatapointDistanceTool;

  j := Listbox1.Items.IndexOfObject(ATool);
  if j > -1 then begin
    Listbox1.Items.Strings[j] := Format(t.Marks.Format, [t.Distance]);
    Listbox1.ItemIndex := j;
  end else
  if TbAdd.Down then begin
    ATool.Enabled := false;
    j := Listbox1.Items.AddObject(Format(t.Marks.Format, [t.Distance]), ATool);
    Listbox1.ItemIndex := j;
  end;
  tbAdd.Down := false;
  tbEdit.Down := true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  tbAddClick(nil);
end;

{ Eine neue Zeile wurde in der Listbox ausgewählt. Ermittelt das ChartTool,
  das zu der neu ausgewählten Zeile gehört und aktiviert dieses. }
procedure TForm1.ListBox1SelectionChange(Sender: TObject; User: boolean);
var
  i: Integer;
  t: TChartTool;
  tListbox: TChartTool;
begin
  if Listbox1.ItemIndex = -1 then
    exit;

  tListbox := Listbox1.Items.Objects[Listbox1.ItemIndex] as TChartTool;
  for t in ChartToolset1.Tools do
    t.Enabled := (t = tListbox);
end;

{ Erzeugt ein neues DistanceTool und macht in der Listbox einen Dummy-Eintrag
  dafür }
procedure TForm1.tbAddClick(Sender: TObject);
var
  t: TDatapointDistanceTool;
  j: Integer;
begin
  tbAdd.Down := true;
  tbEdit.Down := false;
  t := TDatapointDistanceTool.Create(ChartToolset1);
  t.Shift := [ssLeft];
  t.Options := [dpdoPermanent, dpdoClipping];
  t.MeasureMode := cdmOnlyX;
  t.Enabled := true;
  t.OnAfterMouseUp := @ChartToolset1DatapointDistanceTool1AfterMouseUp;
  t.LinePen.Color := clBlue;
  t.PointerStart.VertSize := 10000;
  t.PointerStart.Visible := true;
  t.PointerStart.Pen.Color := clBlue;
  t.PointerEnd.VertSize := 10000;
  t.PointerEnd.Pen.Color := clBlue;
  t.PointerEnd.Visible := true;
  t.Marks.Format := '%0:3f';
  t.DrawingMode := tdmNormal;
  t.Toolset := ChartToolset1;
  j := Listbox1.Items.AddObject('neue Messung...', t);
  Listbox1.ItemIndex := j;
end;

{ Sucht das ChartTool, das zu dem aktuell ausgewählten Listboxeintrag gehört,
  löscht den Listboxeintrag und löscht auch das Tool. }
procedure TForm1.tbDeleteClick(Sender: TObject);
var
  t: TChartTool;
  j: Integer;
begin
  j := Listbox1.ItemIndex;
  if j = -1 then
    exit;
  t := Listbox1.Items.Objects[Listbox1.ItemIndex] as TChartTool;
  Listbox1.Items.Delete(j);
  t.Free;
  Chart1.Refresh;
  Listbox1.ItemIndex := Min(j, Listbox1.Items.Count-1);
end;

{ Der Edit-Button wurde geklickt. Dadurch wird das aktuell markierte
  Distance-Tool aktiviert, wenn der Button "down" ist. Ist der Button nicht
  "down", wird kein ChartTool aktiv und es kann momentan kein Messbalken
  verändert oder hinzugefügt werden. }
procedure TForm1.tbEditClick(Sender: TObject);
var
  t, tListbox: TChartTool;
begin
  tbAdd.Down := false;
  if tbEdit.Down and (Listbox1.ItemIndex > -1) then
    tListbox := Listbox1.Items.Objects[Listbox1.ItemIndex] as TChartTool
  else
    tListbox := nil;
  for t in ChartToolset1.Tools do
    t.Enabled := (t = tListbox);
end;

end.

